﻿/****************************** 
 * Children Flanker Task Test *
 ******************************/

// init psychoJS:
var psychoJS = new PsychoJS({
  debug: true
});

// open window:
psychoJS.openWindow({
  fullscr: true,
  color: new util.Color([(- 1.0), (- 0.38), 0.231]),
  units: 'height',
  waitBlanking: true
});

// store info about the experiment session:
let expName = 'Children Flanker Task';  // from the Builder filename that created this script
let expInfo = {'participant': '', 'session': '001'};

// schedule the experiment:
psychoJS.schedule(psychoJS.gui.DlgFromDict({
  dictionary: expInfo,
  title: expName
}));

const flowScheduler = new Scheduler(psychoJS);
const dialogCancelScheduler = new Scheduler(psychoJS);
psychoJS.scheduleCondition(function() { return (psychoJS.gui.dialogComponent.button === 'OK'); }, flowScheduler, dialogCancelScheduler);

// flowScheduler gets run if the participants presses OK
flowScheduler.add(updateInfo); // add timeStamp
flowScheduler.add(experimentInit);
flowScheduler.add(InstructionsRoutineBegin);
flowScheduler.add(InstructionsRoutineEachFrame);
flowScheduler.add(InstructionsRoutineEnd);
const practice_trialsLoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(practice_trialsLoopBegin, practice_trialsLoopScheduler);
flowScheduler.add(practice_trialsLoopScheduler);
flowScheduler.add(practice_trialsLoopEnd);
flowScheduler.add(Exp_TrialRoutineBegin);
flowScheduler.add(Exp_TrialRoutineEachFrame);
flowScheduler.add(Exp_TrialRoutineEnd);
const exp_trialsLoopScheduler = new Scheduler(psychoJS);
flowScheduler.add(exp_trialsLoopBegin, exp_trialsLoopScheduler);
flowScheduler.add(exp_trialsLoopScheduler);
flowScheduler.add(exp_trialsLoopEnd);
flowScheduler.add(EndRoutineBegin);
flowScheduler.add(EndRoutineEachFrame);
flowScheduler.add(EndRoutineEnd);
flowScheduler.add(quitPsychoJS, '', true);

// quit if user presses Cancel in dialog box:
dialogCancelScheduler.add(quitPsychoJS, '', false);

psychoJS.start({expName, expInfo});

var frameDur;
function updateInfo() {
  expInfo['date'] = util.MonotonicClock.getDateStr();  // add a simple timestamp
  expInfo['expName'] = expName;
  expInfo['psychopyVersion'] = '3.2.4';
  expInfo['OS'] = window.navigator.platform;

  // store frame rate of monitor if we can measure it successfully
  expInfo['frameRate'] = psychoJS.window.getActualFrameRate();
  if (typeof expInfo['frameRate'] !== 'undefined')
    frameDur = 1.0/Math.round(expInfo['frameRate']);
  else
    frameDur = 1.0/60.0; // couldn't get a reliable measure so guess

  // add info from the URL:
  util.addInfoFromUrl(expInfo);
  
  return Scheduler.Event.NEXT;
}

var InstructionsClock;
var instructions;
var key_resp;
var PracticeClock;
var fixation;
var fish_1;
var fish_2;
var target_fish;
var fish_3;
var fish_4;
var response;
var FeedbackClock;
var feedback_text;
var Exp_TrialClock;
var exp_trials_text;
var key_resp_2;
var TrialClock;
var fixation_2;
var Fish_1;
var Fish_2;
var TargetFish;
var Fish_3;
var Fish_4;
var response_2;
var EndClock;
var thank_you;
var globalClock;
var routineTimer;
function experimentInit() {
  // Initialize components for Routine "Instructions"
  InstructionsClock = new util.Clock();
  instructions = new visual.TextStim({
    win: psychoJS.window,
    name: 'instructions',
    text: 'Por favor, observa hacia dónde esta observando el pez del centro. \nSi este pez está observando a la izquierda, presiona la flecha navegadora de la izquierda. Si este pez está observando a la derecha, presiona la flecha navegadora de la derecha. \nIgnora el resto de los peces. Relizarás algunos ensayos con retroalimentación. Por favor, responde tan rápido como puedas. \n\nPresiona la barra espaciadora para comenzar.',
    font: 'Arial',
    units : undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  key_resp = new core.Keyboard({psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "Practice"
  PracticeClock = new util.Clock();
  fixation = new visual.TextStim({
    win: psychoJS.window,
    name: 'fixation',
    text: '+',
    font: 'Arial',
    units : undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  fish_1 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'fish_1', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0, pos : [(- 0.6), 0], size : [0.25, 0.15],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -1.0 
  });
  fish_2 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'fish_2', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0, pos : [(- 0.3), 0], size : [0.25, 0.15],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -2.0 
  });
  target_fish = new visual.ImageStim({
    win : psychoJS.window,
    name : 'target_fish', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0, pos : [0, 0], size : [0.25, 0.15],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -3.0 
  });
  fish_3 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'fish_3', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0, pos : [0.3, 0], size : [0.25, 0.15],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -4.0 
  });
  fish_4 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'fish_4', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0, pos : [0.6, 0], size : [0.25, 0.15],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -5.0 
  });
  response = new core.Keyboard({psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "Feedback"
  FeedbackClock = new util.Clock();
  feedback_text = new visual.TextStim({
    win: psychoJS.window,
    name: 'feedback_text',
    text: 'default text',
    font: 'Arial',
    units : undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: -1.0 
  });
  
  // Initialize components for Routine "Exp_Trial"
  Exp_TrialClock = new util.Clock();
  exp_trials_text = new visual.TextStim({
    win: psychoJS.window,
    name: 'exp_trials_text',
    text: 'Se ha terminado la práctica. \nLa retroalimentación ya no se realizará en el experimento. \n\nPresiona la barra espaciadora para comenzar con el experimento.',
    font: 'Arial',
    units : undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  key_resp_2 = new core.Keyboard({psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "Trial"
  TrialClock = new util.Clock();
  fixation_2 = new visual.TextStim({
    win: psychoJS.window,
    name: 'fixation_2',
    text: '+',
    font: 'Arial',
    units : undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  Fish_1 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Fish_1', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0, pos : [(- 0.6), 0], size : [0.25, 0.15],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -1.0 
  });
  Fish_2 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Fish_2', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0, pos : [(- 0.3), 0], size : [0.25, 0.15],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -2.0 
  });
  TargetFish = new visual.ImageStim({
    win : psychoJS.window,
    name : 'TargetFish', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0, pos : [0, 0], size : [0.25, 0.15],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -3.0 
  });
  Fish_3 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Fish_3', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0, pos : [0.3, 0], size : [0.25, 0.15],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -4.0 
  });
  Fish_4 = new visual.ImageStim({
    win : psychoJS.window,
    name : 'Fish_4', units : undefined, 
    image : undefined, mask : undefined,
    ori : 0, pos : [0.6, 0], size : [0.25, 0.15],
    color : new util.Color([1, 1, 1]), opacity : 1,
    flipHoriz : false, flipVert : false,
    texRes : 128, interpolate : true, depth : -5.0 
  });
  response_2 = new core.Keyboard({psychoJS, clock: new util.Clock(), waitForStart: true});
  
  // Initialize components for Routine "End"
  EndClock = new util.Clock();
  thank_you = new visual.TextStim({
    win: psychoJS.window,
    name: 'thank_you',
    text: 'Se ha finalizado el experimento!\n\nGracias por tu tiempo.',
    font: 'Arial',
    units : undefined, 
    pos: [0, 0], height: 0.05,  wrapWidth: undefined, ori: 0,
    color: new util.Color('white'),  opacity: 1,
    depth: 0.0 
  });
  
  // Create some handy timers
  globalClock = new util.Clock();  // to track the time since experiment started
  routineTimer = new util.CountdownTimer();  // to track time remaining of each (non-slip) routine
  
  return Scheduler.Event.NEXT;
}

var t;
var frameN;
var InstructionsComponents;
function InstructionsRoutineBegin() {
  //------Prepare to start Routine 'Instructions'-------
  t = 0;
  InstructionsClock.reset(); // clock
  frameN = -1;
  // update component parameters for each repeat
  key_resp.keys = undefined;
  key_resp.rt = undefined;
  // keep track of which components have finished
  InstructionsComponents = [];
  InstructionsComponents.push(instructions);
  InstructionsComponents.push(key_resp);
  
  InstructionsComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  
  return Scheduler.Event.NEXT;
}

var continueRoutine;
function InstructionsRoutineEachFrame() {
  //------Loop for each frame of Routine 'Instructions'-------
  let continueRoutine = true; // until we're told otherwise
  // get current time
  t = InstructionsClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  
  // *instructions* updates
  if (t >= 0.0 && instructions.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    instructions.tStart = t;  // (not accounting for frame time here)
    instructions.frameNStart = frameN;  // exact frame index
    instructions.setAutoDraw(true);
  }

  
  // *key_resp* updates
  if (t >= 0.0 && key_resp.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    key_resp.tStart = t;  // (not accounting for frame time here)
    key_resp.frameNStart = frameN;  // exact frame index
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { key_resp.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { key_resp.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { key_resp.clearEvents(); });
  }

  if (key_resp.status === PsychoJS.Status.STARTED) {
    let theseKeys = key_resp.getKeys({keyList: ['space'], waitRelease: false});
    
    // check for quit:
    if (theseKeys.length > 0 && theseKeys[0].name === 'escape') {
      psychoJS.experiment.experimentEnded = true;
    }
    
    if (theseKeys.length > 0) {  // at least one key was pressed
      // a response ends the routine
      continueRoutine = false;
    }
  }
  
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return psychoJS.quit('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  InstructionsComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }});
  
  // refresh the screen if continuing
  if (continueRoutine) {
    return Scheduler.Event.FLIP_REPEAT;
  }
  else {
    return Scheduler.Event.NEXT;
  }
}


function InstructionsRoutineEnd() {
  //------Ending Routine 'Instructions'-------
  InstructionsComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }});
  // the Routine "Instructions" was not non-slip safe, so reset the non-slip timer
  routineTimer.reset();
  
  return Scheduler.Event.NEXT;
}

var practice_trials;
var currentLoop;
var trialIterator;
function practice_trialsLoopBegin(thisScheduler) {
  // set up handler to look after randomisation of conditions etc
  practice_trials = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 1, method: TrialHandler.Method.RANDOM,
    extraInfo: expInfo, originPath: undefined,
    trialList: 'conditions.xlsx',
    seed: undefined, name: 'practice_trials'});
  psychoJS.experiment.addLoop(practice_trials); // add the loop to the experiment
  currentLoop = practice_trials;  // we're now the current loop

  // Schedule all the trials in the trialList:
  trialIterator = practice_trials[Symbol.iterator]();
  while(true) {
    let result = trialIterator.next();
    if (result.done);
      break;
    let thisPractice_trial = result.value;
    thisScheduler.add(importConditions(practice_trials));
    thisScheduler.add(PracticeRoutineBegin);
    thisScheduler.add(PracticeRoutineEachFrame);
    thisScheduler.add(PracticeRoutineEnd);
    thisScheduler.add(FeedbackRoutineBegin);
    thisScheduler.add(FeedbackRoutineEachFrame);
    thisScheduler.add(FeedbackRoutineEnd);
    thisScheduler.add(endLoopIteration({thisScheduler, isTrials : true}));
  }

  return Scheduler.Event.NEXT;
}


function practice_trialsLoopEnd() {
  psychoJS.experiment.removeLoop(practice_trials);

  return Scheduler.Event.NEXT;
}

var exp_trials;
function exp_trialsLoopBegin(thisScheduler) {
  // set up handler to look after randomisation of conditions etc
  exp_trials = new TrialHandler({
    psychoJS: psychoJS,
    nReps: 30, method: TrialHandler.Method.RANDOM,
    extraInfo: expInfo, originPath: undefined,
    trialList: 'conditions.xlsx',
    seed: undefined, name: 'exp_trials'});
  psychoJS.experiment.addLoop(exp_trials); // add the loop to the experiment
  currentLoop = exp_trials;  // we're now the current loop

  // Schedule all the trials in the trialList:
  trialIterator = exp_trials[Symbol.iterator]();
  while(true) {
    let result = trialIterator.next();
    if (result.done);
      break;
    let thisExp_trial = result.value;
    thisScheduler.add(importConditions(exp_trials));
    thisScheduler.add(TrialRoutineBegin);
    thisScheduler.add(TrialRoutineEachFrame);
    thisScheduler.add(TrialRoutineEnd);
    thisScheduler.add(endLoopIteration({thisScheduler, isTrials : true}));
  }

  return Scheduler.Event.NEXT;
}


function exp_trialsLoopEnd() {
  psychoJS.experiment.removeLoop(exp_trials);

  return Scheduler.Event.NEXT;
}

var PracticeComponents;
function PracticeRoutineBegin() {
  //------Prepare to start Routine 'Practice'-------
  t = 0;
  PracticeClock.reset(); // clock
  frameN = -1;
  // update component parameters for each repeat
  fish_1.setImage(fish1);
  fish_2.setImage(fish2);
  target_fish.setImage(targetFish);
  fish_3.setImage(fish3);
  fish_4.setImage(fish4);
  response.keys = undefined;
  response.rt = undefined;
  // keep track of which components have finished
  PracticeComponents = [];
  PracticeComponents.push(fixation);
  PracticeComponents.push(fish_1);
  PracticeComponents.push(fish_2);
  PracticeComponents.push(target_fish);
  PracticeComponents.push(fish_3);
  PracticeComponents.push(fish_4);
  PracticeComponents.push(response);
  
  PracticeComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  
  return Scheduler.Event.NEXT;
}

var frameRemains;
function PracticeRoutineEachFrame() {
  //------Loop for each frame of Routine 'Practice'-------
  let continueRoutine = true; // until we're told otherwise
  // get current time
  t = PracticeClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  
  // *fixation* updates
  if (t >= 0.0 && fixation.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    fixation.tStart = t;  // (not accounting for frame time here)
    fixation.frameNStart = frameN;  // exact frame index
    fixation.setAutoDraw(true);
  }

  frameRemains = 0.0 + 1.0 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (fixation.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    fixation.setAutoDraw(false);
  }
  
  // *fish_1* updates
  if (t >= 1 && fish_1.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    fish_1.tStart = t;  // (not accounting for frame time here)
    fish_1.frameNStart = frameN;  // exact frame index
    fish_1.setAutoDraw(true);
  }

  
  // *fish_2* updates
  if (t >= 1 && fish_2.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    fish_2.tStart = t;  // (not accounting for frame time here)
    fish_2.frameNStart = frameN;  // exact frame index
    fish_2.setAutoDraw(true);
  }

  
  // *target_fish* updates
  if (t >= 1 && target_fish.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    target_fish.tStart = t;  // (not accounting for frame time here)
    target_fish.frameNStart = frameN;  // exact frame index
    target_fish.setAutoDraw(true);
  }

  
  // *fish_3* updates
  if (t >= 1 && fish_3.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    fish_3.tStart = t;  // (not accounting for frame time here)
    fish_3.frameNStart = frameN;  // exact frame index
    fish_3.setAutoDraw(true);
  }

  
  // *fish_4* updates
  if (t >= 1 && fish_4.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    fish_4.tStart = t;  // (not accounting for frame time here)
    fish_4.frameNStart = frameN;  // exact frame index
    fish_4.setAutoDraw(true);
  }

  
  // *response* updates
  if (t >= 1 && response.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    response.tStart = t;  // (not accounting for frame time here)
    response.frameNStart = frameN;  // exact frame index
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { response.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { response.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { response.clearEvents(); });
  }

  if (response.status === PsychoJS.Status.STARTED) {
    let theseKeys = response.getKeys({keyList: ['left', 'right'], waitRelease: false});
    
    // check for quit:
    if (theseKeys.length > 0 && theseKeys[0].name === 'escape') {
      psychoJS.experiment.experimentEnded = true;
    }
    
    if (theseKeys.length > 0) {  // at least one key was pressed
      response.keys = theseKeys[0].name;  // just the last key pressed
      response.rt = theseKeys[0].rt;
      // was this 'correct'?
      if (response.keys === corrAns) {
          response.corr = 1;
      } else {
          response.corr = 0;
      }
      // a response ends the routine
      continueRoutine = false;
    }
  }
  
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return psychoJS.quit('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  PracticeComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }});
  
  // refresh the screen if continuing
  if (continueRoutine) {
    return Scheduler.Event.FLIP_REPEAT;
  }
  else {
    return Scheduler.Event.NEXT;
  }
}


function PracticeRoutineEnd() {
  //------Ending Routine 'Practice'-------
  PracticeComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }});
  // was no response the correct answer?!
  if (response.keys === undefined) {
    if (['None','none',undefined].includes(corrAns)) {
       response.corr = 1  // correct non-response
    } else {
       response.corr = 0  // failed to respond (incorrectly)
    }
  }
  // store data for thisExp (ExperimentHandler)
  psychoJS.experiment.addData('response.keys', response.keys);
  psychoJS.experiment.addData('response.corr', response.corr);
  if (typeof response.keys !== undefined) {  // we had a response
      psychoJS.experiment.addData('response.rt', response.rt);
      routineTimer.reset();
      }
  
  response.stop();
  // the Routine "Practice" was not non-slip safe, so reset the non-slip timer
  routineTimer.reset();
  
  return Scheduler.Event.NEXT;
}

var msg;
var FeedbackComponents;
function FeedbackRoutineBegin() {
  //------Prepare to start Routine 'Feedback'-------
  t = 0;
  FeedbackClock.reset(); // clock
  frameN = -1;
  routineTimer.add(1.000000);
  // update component parameters for each repeat
  if (response.corr==1) {
      msg = "Correcto!";
  } else {
      msg = "Incorrecto";
  }
  feedback_text.setText(msg);
  // keep track of which components have finished
  FeedbackComponents = [];
  FeedbackComponents.push(feedback_text);
  
  FeedbackComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  
  return Scheduler.Event.NEXT;
}


function FeedbackRoutineEachFrame() {
  //------Loop for each frame of Routine 'Feedback'-------
  let continueRoutine = true; // until we're told otherwise
  // get current time
  t = FeedbackClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  
  // *feedback_text* updates
  if (t >= 0.0 && feedback_text.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    feedback_text.tStart = t;  // (not accounting for frame time here)
    feedback_text.frameNStart = frameN;  // exact frame index
    feedback_text.setAutoDraw(true);
  }

  frameRemains = 0.0 + 1.0 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (feedback_text.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    feedback_text.setAutoDraw(false);
  }
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return psychoJS.quit('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  FeedbackComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }});
  
  // refresh the screen if continuing
  if (continueRoutine && routineTimer.getTime() > 0) {
    return Scheduler.Event.FLIP_REPEAT;
  }
  else {
    return Scheduler.Event.NEXT;
  }
}


function FeedbackRoutineEnd() {
  //------Ending Routine 'Feedback'-------
  FeedbackComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }});
  return Scheduler.Event.NEXT;
}

var Exp_TrialComponents;
function Exp_TrialRoutineBegin() {
  //------Prepare to start Routine 'Exp_Trial'-------
  t = 0;
  Exp_TrialClock.reset(); // clock
  frameN = -1;
  // update component parameters for each repeat
  key_resp_2.keys = undefined;
  key_resp_2.rt = undefined;
  // keep track of which components have finished
  Exp_TrialComponents = [];
  Exp_TrialComponents.push(exp_trials_text);
  Exp_TrialComponents.push(key_resp_2);
  
  Exp_TrialComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  
  return Scheduler.Event.NEXT;
}


function Exp_TrialRoutineEachFrame() {
  //------Loop for each frame of Routine 'Exp_Trial'-------
  let continueRoutine = true; // until we're told otherwise
  // get current time
  t = Exp_TrialClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  
  // *exp_trials_text* updates
  if (t >= 0.0 && exp_trials_text.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    exp_trials_text.tStart = t;  // (not accounting for frame time here)
    exp_trials_text.frameNStart = frameN;  // exact frame index
    exp_trials_text.setAutoDraw(true);
  }

  
  // *key_resp_2* updates
  if (t >= 0.0 && key_resp_2.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    key_resp_2.tStart = t;  // (not accounting for frame time here)
    key_resp_2.frameNStart = frameN;  // exact frame index
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { key_resp_2.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { key_resp_2.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { key_resp_2.clearEvents(); });
  }

  if (key_resp_2.status === PsychoJS.Status.STARTED) {
    let theseKeys = key_resp_2.getKeys({keyList: ['space'], waitRelease: false});
    
    // check for quit:
    if (theseKeys.length > 0 && theseKeys[0].name === 'escape') {
      psychoJS.experiment.experimentEnded = true;
    }
    
    if (theseKeys.length > 0) {  // at least one key was pressed
      // a response ends the routine
      continueRoutine = false;
    }
  }
  
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return psychoJS.quit('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  Exp_TrialComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }});
  
  // refresh the screen if continuing
  if (continueRoutine) {
    return Scheduler.Event.FLIP_REPEAT;
  }
  else {
    return Scheduler.Event.NEXT;
  }
}


function Exp_TrialRoutineEnd() {
  //------Ending Routine 'Exp_Trial'-------
  Exp_TrialComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }});
  // the Routine "Exp_Trial" was not non-slip safe, so reset the non-slip timer
  routineTimer.reset();
  
  return Scheduler.Event.NEXT;
}

var TrialComponents;
function TrialRoutineBegin() {
  //------Prepare to start Routine 'Trial'-------
  t = 0;
  TrialClock.reset(); // clock
  frameN = -1;
  // update component parameters for each repeat
  Fish_1.setImage(fish1);
  Fish_2.setImage(fish2);
  TargetFish.setImage(targetFish);
  Fish_3.setImage(fish3);
  Fish_4.setImage(fish4);
  response_2.keys = undefined;
  response_2.rt = undefined;
  // keep track of which components have finished
  TrialComponents = [];
  TrialComponents.push(fixation_2);
  TrialComponents.push(Fish_1);
  TrialComponents.push(Fish_2);
  TrialComponents.push(TargetFish);
  TrialComponents.push(Fish_3);
  TrialComponents.push(Fish_4);
  TrialComponents.push(response_2);
  
  TrialComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  
  return Scheduler.Event.NEXT;
}


function TrialRoutineEachFrame() {
  //------Loop for each frame of Routine 'Trial'-------
  let continueRoutine = true; // until we're told otherwise
  // get current time
  t = TrialClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  
  // *fixation_2* updates
  if (t >= 0.0 && fixation_2.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    fixation_2.tStart = t;  // (not accounting for frame time here)
    fixation_2.frameNStart = frameN;  // exact frame index
    fixation_2.setAutoDraw(true);
  }

  frameRemains = 0.0 + 1.0 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (fixation_2.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    fixation_2.setAutoDraw(false);
  }
  
  // *Fish_1* updates
  if (t >= 1 && Fish_1.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    Fish_1.tStart = t;  // (not accounting for frame time here)
    Fish_1.frameNStart = frameN;  // exact frame index
    Fish_1.setAutoDraw(true);
  }

  
  // *Fish_2* updates
  if (t >= 1 && Fish_2.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    Fish_2.tStart = t;  // (not accounting for frame time here)
    Fish_2.frameNStart = frameN;  // exact frame index
    Fish_2.setAutoDraw(true);
  }

  
  // *TargetFish* updates
  if (t >= 1 && TargetFish.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    TargetFish.tStart = t;  // (not accounting for frame time here)
    TargetFish.frameNStart = frameN;  // exact frame index
    TargetFish.setAutoDraw(true);
  }

  
  // *Fish_3* updates
  if (t >= 1 && Fish_3.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    Fish_3.tStart = t;  // (not accounting for frame time here)
    Fish_3.frameNStart = frameN;  // exact frame index
    Fish_3.setAutoDraw(true);
  }

  
  // *Fish_4* updates
  if (t >= 1 && Fish_4.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    Fish_4.tStart = t;  // (not accounting for frame time here)
    Fish_4.frameNStart = frameN;  // exact frame index
    Fish_4.setAutoDraw(true);
  }

  
  // *response_2* updates
  if (t >= 1 && response_2.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    response_2.tStart = t;  // (not accounting for frame time here)
    response_2.frameNStart = frameN;  // exact frame index
    // keyboard checking is just starting
    psychoJS.window.callOnFlip(function() { response_2.clock.reset(); });  // t=0 on next screen flip
    psychoJS.window.callOnFlip(function() { response_2.start(); }); // start on screen flip
    psychoJS.window.callOnFlip(function() { response_2.clearEvents(); });
  }

  if (response_2.status === PsychoJS.Status.STARTED) {
    let theseKeys = response_2.getKeys({keyList: ['left', 'right'], waitRelease: false});
    
    // check for quit:
    if (theseKeys.length > 0 && theseKeys[0].name === 'escape') {
      psychoJS.experiment.experimentEnded = true;
    }
    
    if (theseKeys.length > 0) {  // at least one key was pressed
      response_2.keys = theseKeys[0].name;  // just the last key pressed
      response_2.rt = theseKeys[0].rt;
      // was this 'correct'?
      if (response_2.keys === corrAns) {
          response_2.corr = 1;
      } else {
          response_2.corr = 0;
      }
      // a response ends the routine
      continueRoutine = false;
    }
  }
  
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return psychoJS.quit('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  TrialComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }});
  
  // refresh the screen if continuing
  if (continueRoutine) {
    return Scheduler.Event.FLIP_REPEAT;
  }
  else {
    return Scheduler.Event.NEXT;
  }
}


function TrialRoutineEnd() {
  //------Ending Routine 'Trial'-------
  TrialComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }});
  // was no response the correct answer?!
  if (response_2.keys === undefined) {
    if (['None','none',undefined].includes(corrAns)) {
       response_2.corr = 1  // correct non-response
    } else {
       response_2.corr = 0  // failed to respond (incorrectly)
    }
  }
  // store data for thisExp (ExperimentHandler)
  psychoJS.experiment.addData('response_2.keys', response_2.keys);
  psychoJS.experiment.addData('response_2.corr', response_2.corr);
  if (typeof response_2.keys !== undefined) {  // we had a response
      psychoJS.experiment.addData('response_2.rt', response_2.rt);
      routineTimer.reset();
      }
  
  response_2.stop();
  // the Routine "Trial" was not non-slip safe, so reset the non-slip timer
  routineTimer.reset();
  
  return Scheduler.Event.NEXT;
}

var EndComponents;
function EndRoutineBegin() {
  //------Prepare to start Routine 'End'-------
  t = 0;
  EndClock.reset(); // clock
  frameN = -1;
  routineTimer.add(3.000000);
  // update component parameters for each repeat
  // keep track of which components have finished
  EndComponents = [];
  EndComponents.push(thank_you);
  
  EndComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent)
      thisComponent.status = PsychoJS.Status.NOT_STARTED;
     });
  
  return Scheduler.Event.NEXT;
}


function EndRoutineEachFrame() {
  //------Loop for each frame of Routine 'End'-------
  let continueRoutine = true; // until we're told otherwise
  // get current time
  t = EndClock.getTime();
  frameN = frameN + 1;// number of completed frames (so 0 is the first frame)
  // update/draw components on each frame
  
  // *thank_you* updates
  if (t >= 0.0 && thank_you.status === PsychoJS.Status.NOT_STARTED) {
    // keep track of start time/frame for later
    thank_you.tStart = t;  // (not accounting for frame time here)
    thank_you.frameNStart = frameN;  // exact frame index
    thank_you.setAutoDraw(true);
  }

  frameRemains = 0.0 + 3 - psychoJS.window.monitorFramePeriod * 0.75;  // most of one frame period left
  if (thank_you.status === PsychoJS.Status.STARTED && t >= frameRemains) {
    thank_you.setAutoDraw(false);
  }
  // check for quit (typically the Esc key)
  if (psychoJS.experiment.experimentEnded || psychoJS.eventManager.getKeys({keyList:['escape']}).length > 0) {
    return psychoJS.quit('The [Escape] key was pressed. Goodbye!', false);
  }
  
  // check if the Routine should terminate
  if (!continueRoutine) {  // a component has requested a forced-end of Routine
    return Scheduler.Event.NEXT;
  }
  
  continueRoutine = false;  // reverts to True if at least one component still running
  EndComponents.forEach( function(thisComponent) {
    if ('status' in thisComponent && thisComponent.status !== PsychoJS.Status.FINISHED) {
      continueRoutine = true;
    }});
  
  // refresh the screen if continuing
  if (continueRoutine && routineTimer.getTime() > 0) {
    return Scheduler.Event.FLIP_REPEAT;
  }
  else {
    return Scheduler.Event.NEXT;
  }
}


function EndRoutineEnd() {
  //------Ending Routine 'End'-------
  EndComponents.forEach( function(thisComponent) {
    if (typeof thisComponent.setAutoDraw === 'function') {
      thisComponent.setAutoDraw(false);
    }});
  return Scheduler.Event.NEXT;
}


function endLoopIteration({thisScheduler, isTrials=true}) {
  // ------Prepare for next entry------
  return function () {
    // ------Check if user ended loop early------
    if (currentLoop.finished) {
      // Check for and save orphaned data
      if (Object.keys(psychoJS.experiment._thisEntry).length > 0) {
        psychoJS.experiment.nextEntry();
      }
      thisScheduler.stop();
    } else if (isTrials) {
      psychoJS.experiment.nextEntry();
    }
  return Scheduler.Event.NEXT;
  };
}


function importConditions(loop) {
  const trialIndex = loop.getTrialIndex();
  return function () {
    loop.setTrialIndex(trialIndex);
    psychoJS.importAttributes(loop.getCurrentTrial());
    return Scheduler.Event.NEXT;
    };
}


function quitPsychoJS(message, isCompleted) {
  // Check for and save orphaned data
  if (Object.keys(psychoJS.experiment._thisEntry).length > 0) {
    psychoJS.experiment.nextEntry();
  }
  psychoJS.window.close();
  psychoJS.quit({message: message, isCompleted: isCompleted});

  return Scheduler.Event.QUIT;
}
